/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package test.sender;

import java.util.Date;
import java.util.Properties;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.annotation.Resource;
import javax.ejb.LocalBean;
import javax.ejb.Stateless;
import javax.jms.*;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

/**
 *
 * @author LILIZHAO
 */
@Stateless
@LocalBean
public class SenderEjb implements SenderEjbLocal {
    private final Logger logger = Logger.getLogger(SenderEjb.class.getName());
    
    @Override
    public void sendMessage() {
        QueueConnection qcon = null;
        QueueSession qsession = null;
        QueueSender qsender = null;
        try {
            Properties jndiProps = new Properties();
            //jndiProps.put(Context.SECURITY_PRINCIPAL, "admin");
            //jndiProps.put(Context.SECURITY_CREDENTIALS, "adminadmin"); 
            jndiProps.put("java.naming.factory.initial", "com.sun.enterprise.naming.impl.SerialInitContextFactory");
            jndiProps.put("java.naming.factory.url.pkgs", "com.sun.enterprise.naming");
            jndiProps.put("java.naming.factory.state", "com.sun.corba.ee.impl.presentation.rmi.JNDIStateFactoryImpl");
            jndiProps.setProperty("org.omg.CORBA.ORBInitialHost", "localhost");
            jndiProps.setProperty("org.omg.CORBA.ORBInitialPort", "3700"); 
            
            // Lookup queue from remote server.
            Context ctx = new InitialContext(jndiProps);
            Queue queue = (Queue) ctx.lookup("jms/isef_cvm");
            logger.info("Queue: " + queue);

            // Lookup ConnectionFactory from local server.
            Context ctx1 = new InitialContext();
            QueueConnectionFactory qconFactory = (QueueConnectionFactory) ctx1.lookup("jms/SenderFactory");
            logger.info("CF: " + qconFactory);

            qcon = qconFactory.createQueueConnection();
            qsession = qcon.createQueueSession(false, Session.AUTO_ACKNOWLEDGE);
            qsender = qsession.createSender(queue);
            TextMessage msg = qsession.createTextMessage();
            qcon.start();

            msg.setText("Hello World!!! " + new Date());
            msg.setJMSReplyTo(qsession.createTemporaryQueue());
            qsender.send(msg);
        } catch (Exception e) {
            logger.log(Level.SEVERE, "Error sending message", e);
        } finally {
            try {
                if (qsender != null)
                    qsender.close();
                if (qsession != null)
                    qsession.close();
                if (qcon != null)
                    qcon.close();
            } catch (Exception e) {
                logger.log(Level.SEVERE, "Error closing connections", e);
            }
        }
        
    }

    // Add business logic below. (Right-click in editor and choose
    // "Insert Code > Add Business Method")
    
}
